unit Unit9;

interface

uses
  Classes, SysUtils, IWAppForm, IWApplication, IWColor, IWTypes, DB,
  ADODB, Controls, IWVCLBaseControl, IWBaseControl,
  IWBaseHTMLControl, IWControl, IWCompButton, IWCompLabel, IWCompEdit,
  IWDBStdCtrls, Forms, IWVCLBaseContainer, IWContainer, IWHTMLContainer,
  IWHTML40Container, IWRegion, IWBaseComponent, IWBaseHTMLComponent,
  IWBaseHTML40Component, IWTMSAuthBase, IWFacebookAuthClient, IWHTMLControls,
  IWExtCtrls;

type
  TIWForm9 = class(TIWAppForm)
    DataSource1: TDataSource;
    ADOConnection1: TADOConnection;
    ADOQuery1: TADOQuery;
    btLogin: TIWButton;
    btLogout: TIWButton;
    IWLabel5: TIWLabel;
    IWImageFile1: TIWImageFile;
    TIWFacebookAuthClient1: TTIWFacebookAuthClient;
    edSecret: TIWEdit;
    IWLabel9: TIWLabel;
    IWLabel7: TIWLabel;
    edID: TIWEdit;
    IWLabel1: TIWLabel;
    IWLabel2: TIWLabel;
    IWLabel3: TIWLabel;
    IWLabel4: TIWLabel;
    btPost: TIWButton;
    IWLabel14: TIWLabel;
    IWLabel11: TIWLabel;
    IWLabel12: TIWLabel;
    IWLabel13: TIWLabel;
    lbBirthday: TIWLabel;
    lbEmail: TIWLabel;
    imgProfile: TIWImageFile;
    btSave: TIWButton;
    IWDBEdit3: TIWDBEdit;
    IWDBEdit2: TIWDBEdit;
    IWDBEdit1: TIWDBEdit;
    IWLink1: TIWLink;
    IWLabel6: TIWLabel;
    IWLabel8: TIWLabel;
    lbLocalHost: TIWLabel;
    procedure IWAppFormCreate(Sender: TObject);
    procedure btLoginClick(Sender: TObject);
    procedure ToggleVisibility(Tag: integer; Visible: boolean);
    procedure CheckLogin(ID, Name, Error, Service: string; Result: TIWResult);
    procedure btLogoutClick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure btPostClick(Sender: TObject);
    procedure TIWFacebookAuthClient1LoginFailed(Sender: TObject);
    procedure TIWFacebookAuthClient1LoginOK(Sender: TObject);
    procedure TIWFacebookAuthClient1PostFailed(Sender: TObject;
      ErrorMessage: string);
    procedure TIWFacebookAuthClient1PostOK(Sender: TObject; PostID: string);
    procedure IWAppFormRender(Sender: TObject);
  public
  end;

implementation

{$R *.dfm}

uses ServerController;

procedure TIWForm9.btLogoutClick(Sender: TObject);
begin
  btLogin.Visible := true;
  btLogout.Visible := false;
  ToggleVisibility(1, false);
  ToggleVisibility(2, false);
  IWLink1.Visible := false;
  TIWFacebookAuthClient1.LoginID := '';
  TIWFacebookAuthClient1.LoginUserName := '';
  TIWFacebookAuthClient1.LoginResult := resNone;
end;

procedure TIWForm9.btPostClick(Sender: TObject);
begin
  if (IWDBEdit1.Text <> '') and (IWDBEdit2.Text <> '') and (IWDBEdit2.Text <> '') then
  begin
    ToggleVisibility(2, true);
    IWLink1.Visible := true;
    TIWFacebookAuthClient1.Post('I''m a Delphi ' + IWDBEdit1.Text
    + ' user with IntraWeb ' + IWDBEdit2.Text + ' and the ' + IWDBEdit3.Text + ' browser');
  end
  else
    WebApplication.ShowMessage('Please fill in all fields first.')
end;

procedure TIWForm9.btSaveClick(Sender: TObject);
begin
  DataSource1.DataSet.Active := true;
  DataSource1.DataSet.Edit;
  DataSource1.DataSet.Post;
  DataSource1.DataSet.Edit;
  WebApplication.ShowMessage('Data saved');
end;

procedure TIWForm9.CheckLogin(ID, Name, Error, Service: string; Result: TIWResult);
var
  select: string;
begin
  if (Result = resOK) and
    (ID <> '') and (Name <> '') and (Service <> '') then
  begin
    IWLabel1.Text := 'Hello ' + Name + '!';

    select := 'SELECT * FROM [Users] WHERE [UserID] = "' + ID + '" and [Service] = "' + Service + '"';
    ADOQuery1.SQL.Text := select;
    DataSource1.DataSet.Active := true;

    //Create local account
    if DataSource1.DataSet.RecordCount = 0 then
    begin
      DataSource1.DataSet.Insert;
      DataSource1.DataSet.FieldValues['UserID'] := ID;
      DataSource1.DataSet.FieldValues['Service'] := Service;
      DataSource1.DataSet.Post;

      ADOQuery1.SQL.Text := select;
      DataSource1.DataSet.Active := true;
    end;

    IWDBEdit1.DataSource := DataSource1;
    IWDBEdit1.DataField := 'Data1';
    IWDBEdit2.DataSource := DataSource1;
    IWDBEdit2.DataField := 'Data2';
    IWDBEdit3.DataSource := DataSource1;
    IWDBEdit3.DataField := 'Data3';

    DataSource1.DataSet.Edit;

    ToggleVisibility(1, true);
    btLogin.Visible := false;
    btLogout.Visible := true;
    lbEmail.Text := TIWFacebookAuthClient1.User.Email;
    lbBirthday.Text := TIWFacebookAuthClient1.User.Birthday;
    imgProfile.ImageFile.URL := TIWFacebookAuthClient1.User.Picture;
  end
  else if (Result = resFailed) then
  begin
    ToggleVisibility(2, true);
    IWLabel8.Text := 'Login Failed';
    IWLabel6.Text := Error;
    IWLink1.Visible := false;
    TIWFacebookAuthClient1.LoginResult := resNone;
  end;
end;

procedure TIWForm9.ToggleVisibility(Tag: integer; Visible: boolean);
var
  I: integer;
begin
  for I := 0 to ControlCount - 1 do
  begin
    if Controls[I].Tag = Tag then
    begin
      TIWControl(Controls[I]).Visible := Visible;
    end;
  end;
end;

procedure TIWForm9.btLoginClick(Sender: TObject);
begin
  if edID.Text <> EmptyStr then
    TIWFacebookAuthClient1.App.ID := edID.Text;
  if edSecret.Text <> EmptyStr then
    TIWFacebookAuthClient1.App.Secret := edSecret.Text;

  if (TIWFacebookAuthClient1.App.ID <> EmptyStr)
    and (TIWFacebookAuthClient1.App.ID <> EmptyStr) then
  begin
  ToggleVisibility(2, false);
  IWLink1.Visible := false;
  TIWFacebookAuthClient1.Login(WebApplication);
  end
  else
    WebApplication.ShowMessage('Please fill in your App ID and App Secret.');
end;

procedure TIWForm9.IWAppFormCreate(Sender: TObject);
begin
  DataSource1.DataSet.Active := false;
  ADOConnection1.ConnectionString :=
    'Provider=Microsoft.Jet.OLEDB.4.0;Password="";Persist Security Info=True;Data Source= ' +
  WebApplication.ApplicationPath + './users.mdb';
  DataSource1.DataSet.Active := true;

  TIWFacebookAuthClient1.ServerController := IWServerController.TIWAuthServerController1;
  TIWFacebookAuthClient1.Scopes := [fbEmail, fbBirthday];

  btLogin.Visible := true;
  btLogout.Visible := false;
  ToggleVisibility(1, false);
  ToggleVisibility(2, false);
  IWLink1.Visible := false;
  lbLocalHost.Visible := false;
end;


procedure TIWForm9.IWAppFormRender(Sender: TObject);
begin
  if pos('127.0.0.1', WebApplication.ApplicationURL) > 0 then
    lbLocalHost.Visible := true
  else
    lbLocalHost.Visible := false;
end;

procedure TIWForm9.TIWFacebookAuthClient1LoginFailed(Sender: TObject);
begin
  CheckLogin(TIWFacebookAuthClient1.LoginID, TIWFacebookAuthClient1.LoginUsername,
    TIWFacebookAuthClient1.LoginError, 'Facebook', TIWFacebookAuthClient1.LoginResult);
end;

procedure TIWForm9.TIWFacebookAuthClient1LoginOK(Sender: TObject);
begin
  CheckLogin(TIWFacebookAuthClient1.LoginID, TIWFacebookAuthClient1.LoginUsername,
    TIWFacebookAuthClient1.LoginError, 'Facebook', TIWFacebookAuthClient1.LoginResult);
end;

procedure TIWForm9.TIWFacebookAuthClient1PostFailed(Sender: TObject;
  ErrorMessage: string);
begin
  ToggleVisibility(2, true);
  IWLabel8.Text := 'Post failed';
  IWLabel6.Text := ErrorMessage;
  IWLink1.Visible := false;
end;

procedure TIWForm9.TIWFacebookAuthClient1PostOK(Sender: TObject;
  PostID: string);
begin
  ToggleVisibility(2, true);
  IWLabel8.Text := 'Post OK';
  IWLabel6.Text := PostID;
  IWLink1.Visible := true;
  IWLink1.ScriptEvents.HookEvent('onClick', 'window.open("'
   + 'http://www.facebook.com/#!/permalink.php?story_fbid='
   + PostID + '&id='
   + TIWFacebookAuthClient1.LoginID + '", "_blank"); return false;');
end;

initialization
  TIWForm9.SetAsMainForm;

end.
